"use strict";
var Symbol = require("es6-symbol");
var ownKeys = require("reflect.ownkeys");
function mixin(behaviour, sharedBehaviour) {
    if (sharedBehaviour === void 0) { sharedBehaviour = {}; }
    // these keys reflect the behaviour that is to be attached to class instances
    var instanceKeys = ownKeys(behaviour);
    // these keys reflect static behaviour
    var sharedKeys = ownKeys(sharedBehaviour);
    var typeTag = Symbol("isA");
    function _mixin(workingClass) {
        // attach instance-oriented behaviour
        for (var _i = 0, instanceKeys_1 = instanceKeys; _i < instanceKeys_1.length; _i++) {
            var property = instanceKeys_1[_i];
            Object.defineProperty(workingClass.prototype, property, { value: behaviour[property] });
        }
        Object.defineProperty(workingClass.prototype, typeTag, { value: true });
    }
    // attach static behaviour
    for (var _i = 0, sharedKeys_1 = sharedKeys; _i < sharedKeys_1.length; _i++) {
        var property = sharedKeys_1[_i];
        Object.defineProperty(_mixin, property, {
            enumerable: sharedBehaviour.propertyIsEnumerable(property),
            value: sharedBehaviour[property],
        });
    }
    // this allows you to use "instanceof" on an object that uses a mixin
    Object.defineProperty(_mixin, Symbol.hasInstance, {
        value: function (instance) { return !!instance[typeTag]; },
    });
    return _mixin;
}
exports.mixin = mixin;
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = mixin;
